Package org.mariadb.jdbc.client.socket.impl

## Class CompressOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - org.mariadb.jdbc.client.socket.impl.CompressOutputStream

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

    public class CompressOutputStream
    extends OutputStream

### Constructor Summary

Constructors
`CompressOutputStream​(OutputStream out, MutableInt compressionSequence)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `close()` Closes this output stream and releases any system resources associated with this stream.
`void` `flush()` Flushes this output stream and forces any buffered output bytes to be written out.
`void` `setMaxAllowedPacket​(int maxAllowedPacket)`
`void` `write​(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this output stream.
`void` `write​(int b)` Writes the specified byte to this output stream.

### Methods inherited from class java.io.OutputStream

`nullOutputStream, write`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CompressOutputStream

    public CompressOutputStream​(OutputStream out,
                                MutableInt compressionSequence)

### Method Detail

#### setMaxAllowedPacket

    public void setMaxAllowedPacket​(int maxAllowedPacket)

#### write

    public void write​(byte[] b,
                      int off,
                      int len)
               throws IOException

Writes `len` bytes from the specified byte array starting at offset `off` to this output stream. The general contract for `write(b, off, len)` is that some bytes in the array `b` are written to the output stream in order; element `b[off]` is the first byte written and `b[off+len-1]` is the last byte written by this operation.

The `write` method of `OutputStream` calls the write method of one argument on each of the bytes to be written out. Subclasses are encouraged to override this method and provide a more efficient implementation.

If `b` is `null`, a `NullPointerException` is thrown.

If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an IndexOutOfBoundsException is thrown.

Overrides:
  `write` in class `OutputStream`
Parameters:
  `b` - the data.
  `off` - the start offset in the data.
  `len` - the number of bytes to write.
Throws:
  `IOException` - if an I/O error occurs. In particular, an `IOException` is thrown if the output stream is closed.

#### flush

    public void flush()
               throws IOException

Flushes this output stream and forces any buffered output bytes to be written out. The general contract of `flush` is that calling it is an indication that, if any bytes previously written have been buffered by the implementation of the output stream, such bytes should immediately be written to their intended destination.

If the intended destination of this stream is an abstraction provided by the underlying operating system, for example a file, then flushing the stream guarantees only that bytes previously written to the stream are passed to the operating system for writing; it does not guarantee that they are actually written to a physical device such as a disk drive.

The `flush` method of `OutputStream` does nothing.

Specified by:
  `flush` in interface `Flushable`
Overrides:
  `flush` in class `OutputStream`
Throws:
  `IOException` - if an I/O error occurs.

#### close

    public void close()
               throws IOException

Closes this output stream and releases any system resources associated with this stream. The general contract of `close` is that it closes the output stream. A closed stream cannot perform output operations and cannot be reopened.

The `close` method of `OutputStream` does nothing.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Overrides:
  `close` in class `OutputStream`
Throws:
  `IOException` - if an I/O error occurs.

#### write

    public void write​(int b)
               throws IOException

Writes the specified byte to this output stream. The general contract for `write` is that one byte is written to the output stream. The byte to be written is the eight low-order bits of the argument `b`. The 24 high-order bits of `b` are ignored.

Subclasses of `OutputStream` must provide an implementation for this method.

Specified by:
  `write` in class `OutputStream`
Parameters:
  `b` - the `byte`.
Throws:
  `IOException` - if an I/O error occurs. In particular, an `IOException` may be thrown if the output stream has been closed.